blob: 9e0be1cb081327557046b696e3cb69d4ab606281 [file] [log] [blame]
Linus Torvalds1da177e2005-04-16 15:20:36 -07001# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
Michal Marek1cba0c32015-04-08 11:11:57 +02005PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
Steven Rostedt281c9da2009-04-29 22:52:23 -04006 localmodconfig localyesconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -07007
Al Viro61bee202008-08-25 04:51:27 -04008ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
Arnaud Lacombe838a2e52010-09-04 17:10:20 -040011Kconfig := Kconfig
Al Viro61bee202008-08-25 04:51:27 -040012endif
Sam Ravnborge703f752007-10-25 20:42:18 +020013
Michal Marek0a1f00a2015-04-08 13:30:42 +020014ifeq ($(quiet),silent_)
15silent := -s
16endif
17
Yann E. MORINc2838e62012-11-22 01:06:04 +010018# We need this, in case the user has it in its environment
19unexport CONFIG_
20
Linus Torvalds1da177e2005-04-16 15:20:36 -070021xconfig: $(obj)/qconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020022 $< $(silent) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070023
24gconfig: $(obj)/gconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020025 $< $(silent) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070026
27menuconfig: $(obj)/mconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020028 $< $(silent) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070029
30config: $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +020031 $< $(silent) --oldaskconfig $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070032
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +020033nconfig: $(obj)/nconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020034 $< $(silent) $(Kconfig)
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +020035
Linus Torvalds1da177e2005-04-16 15:20:36 -070036silentoldconfig: $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090037 $(Q)mkdir -p include/config include/generated
Michal Marek0a1f00a2015-04-08 13:30:42 +020038 $< $(silent) --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070039
Arnaud Lacombe50bce3e2011-07-01 18:13:03 -040040localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090041 $(Q)mkdir -p include/config include/generated
Arnaud Lacombe22d550a2011-07-20 00:40:09 -040042 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
Michal Marek7a996d32010-08-04 14:05:07 +020043 $(Q)if [ -f .config ]; then \
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020044 cmp -s .tmp.config .config || \
45 (mv -f .config .config.old.1; \
46 mv -f .tmp.config .config; \
Michal Marek0a1f00a2015-04-08 13:30:42 +020047 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020048 mv -f .config.old.1 .config.old) \
49 else \
50 mv -f .tmp.config .config; \
Michal Marek0a1f00a2015-04-08 13:30:42 +020051 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
Steven Rostedta7c02602009-05-07 11:09:55 -040052 fi
Steven Rostedt03fa25d2009-04-29 22:52:22 -040053 $(Q)rm -f .tmp.config
54
EGRY Gabor10200262008-01-11 23:40:00 +010055# Create new linux.pot file
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020056# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
EGRY Gabor46d26312008-01-11 23:46:11 +010057update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
Michal Marek0a1f00a2015-04-08 13:30:42 +020058 $(Q)$(kecho) " GEN config.pot"
Peter Foleya24a1b82011-04-26 18:13:05 -040059 $(Q)xgettext --default-domain=linux \
60 --add-comments --keyword=_ --keyword=N_ \
61 --from-code=UTF-8 \
62 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
63 --directory=$(srctree) --directory=$(objtree) \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020064 --output $(obj)/config.pot
65 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
Paul Bollefa0ad6572011-11-05 12:21:30 +010066 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
67 $(srctree)/arch/*/um/Kconfig`; \
EGRY Gabor10200262008-01-11 23:40:00 +010068 do \
Michal Marek0a1f00a2015-04-08 13:30:42 +020069 $(kecho) " GEN $$i"; \
Sam Ravnborg42175162008-04-25 21:15:41 +020070 $(obj)/kxgettext $$i \
EGRY Gabor10200262008-01-11 23:40:00 +010071 >> $(obj)/config.pot; \
72 done )
Michal Marek0a1f00a2015-04-08 13:30:42 +020073 $(Q)$(kecho) " GEN linux.pot"
EGRY Gabor10200262008-01-11 23:40:00 +010074 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020075 --output $(obj)/linux.pot
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020076 $(Q)rm -f $(obj)/config.pot
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -070077
Michal Marek1cba0c32015-04-08 11:11:57 +020078# These targets map 1:1 to the commandline options of 'conf'
79simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80 alldefconfig randconfig listnewconfig olddefconfig
81PHONY += $(simple-targets)
Linus Torvalds1da177e2005-04-16 15:20:36 -070082
Michal Marek1cba0c32015-04-08 11:11:57 +020083$(simple-targets): $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +020084 $< $(silent) --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070085
Michal Marek1cba0c32015-04-08 11:11:57 +020086PHONY += oldnoconfig savedefconfig defconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -070087
Adam Leefb16d892012-09-01 01:05:17 +080088# oldnoconfig is an alias of olddefconfig, because people already are dependent
Diego Viola39c3f1b2015-05-31 14:35:51 -030089# on its behavior (sets new symbols to their default value but not 'n') with the
Adam Leefb16d892012-09-01 01:05:17 +080090# counter-intuitive name.
Michal Marek1cba0c32015-04-08 11:11:57 +020091oldnoconfig: olddefconfig
Adam Leefb16d892012-09-01 01:05:17 +080092
Sam Ravnborg7cf3d732010-07-31 23:35:34 +020093savedefconfig: $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +020094 $< $(silent) --$@=defconfig $(Kconfig)
Sam Ravnborg7cf3d732010-07-31 23:35:34 +020095
Linus Torvalds1da177e2005-04-16 15:20:36 -070096defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
Michal Marek0a1f00a2015-04-08 13:30:42 +020098 $< $(silent) --defconfig $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070099else
Michal Marek0a1f00a2015-04-08 13:30:42 +0200100 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700102endif
103
104%_defconfig: $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +0200105 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700106
Masahiro Yamada63a91032015-03-13 15:21:43 +0900107configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
Josh Triplett3aaefce2014-08-06 15:21:00 -0700108
Masahiro Yamada63a91032015-03-13 15:21:43 +0900109%.config: $(obj)/conf
110 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
111 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
112 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
Josh Triplett3aaefce2014-08-06 15:21:00 -0700113
114PHONY += kvmconfig
Masahiro Yamada63a91032015-03-13 15:21:43 +0900115kvmconfig: kvm_guest.config
116 @:
Josh Triplett3aaefce2014-08-06 15:21:00 -0700117
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700118PHONY += tinyconfig
Masahiro Yamada63a91032015-03-13 15:21:43 +0900119tinyconfig:
120 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700121
Linus Torvalds1da177e2005-04-16 15:20:36 -0700122# Help text used by make help
123help:
124 @echo ' config - Update current config utilising a line-oriented program'
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200125 @echo ' nconfig - Update current config utilising a ncurses menu based program'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700126 @echo ' menuconfig - Update current config utilising a menu based program'
Diego Viola092373c2015-04-06 06:27:45 -0300127 @echo ' xconfig - Update current config utilising a Qt based front-end'
Diego Viola39c3f1b2015-05-31 14:35:51 -0300128 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700129 @echo ' oldconfig - Update current config utilising a provided .config as base'
Steven Rostedt03fa25d2009-04-29 22:52:22 -0400130 @echo ' localmodconfig - Update current config disabling modules not loaded'
Steven Rostedt281c9da2009-04-29 22:52:23 -0400131 @echo ' localyesconfig - Update current config converting local mods to core'
Markus Heidelberg590a5852009-05-18 01:36:46 +0200132 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200133 @echo ' defconfig - New config with default from ARCH supplied defconfig'
Sam Ravnborg7cf3d732010-07-31 23:35:34 +0200134 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
Jesper Juhle11f0492006-02-25 21:52:50 +0100135 @echo ' allnoconfig - New config where all options are answered with no'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200136 @echo ' allyesconfig - New config where all options are accepted with yes'
137 @echo ' allmodconfig - New config selecting modules when possible'
138 @echo ' alldefconfig - New config with all symbols set to default'
139 @echo ' randconfig - New config with random answer to all options'
Sam Ravnborg861b4ea2010-07-31 23:35:28 +0200140 @echo ' listnewconfig - List new options'
Adam Leefb16d892012-09-01 01:05:17 +0800141 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
Josh Triplett3aaefce2014-08-06 15:21:00 -0700142 @echo ' kvmconfig - Enable additional options for guest kernel support'
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700143 @echo ' tinyconfig - Configure the tiniest possible kernel'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700144
Sam Ravnborg2982de62006-07-27 22:10:27 +0200145# lxdialog stuff
146check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
147
Rob Landleye9e40e12007-10-15 19:23:12 -0500148# Use recursively expanded variables so we do not call gcc unless
Sam Ravnborg2982de62006-07-27 22:10:27 +0200149# we really need to do so. (Do not call gcc as part of make mrproper)
Arnaud Lacombe9ba95682010-08-22 20:03:06 -0400150HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
151 -DLOCALE
Sam Ravnborg2982de62006-07-27 22:10:27 +0200152
Linus Torvalds1da177e2005-04-16 15:20:36 -0700153# ===========================================================================
154# Shared Makefile for the various kconfig executables:
155# conf: Used for defconfig, oldconfig and related targets
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200156# nconf: Used for the nconfig target.
157# Utilizes ncurses
Markus Heidelberg6f26e5e2009-05-18 01:36:45 +0200158# mconf: Used for the menuconfig target
Linus Torvalds1da177e2005-04-16 15:20:36 -0700159# Utilizes the lxdialog package
160# qconf: Used for the xconfig target
Diego Viola092373c2015-04-06 06:27:45 -0300161# Based on Qt which needs to be installed to compile it
Linus Torvalds1da177e2005-04-16 15:20:36 -0700162# gconf: Used for the gconfig target
Diego Viola39c3f1b2015-05-31 14:35:51 -0300163# Based on GTK+ which needs to be installed to compile it
Linus Torvalds1da177e2005-04-16 15:20:36 -0700164# object files used by all kconfig flavours
165
Sam Ravnborg2982de62006-07-27 22:10:27 +0200166lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
167lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
168
Linus Torvalds1da177e2005-04-16 15:20:36 -0700169conf-objs := conf.o zconf.tab.o
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200170mconf-objs := mconf.o zconf.tab.o $(lxdialog)
171nconf-objs := nconf.o zconf.tab.o nconf.gui.o
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -0700172kxgettext-objs := kxgettext.o zconf.tab.o
Peter Foleyf1943042011-04-26 18:00:05 -0400173qconf-cxxobjs := qconf.o
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400174qconf-objs := zconf.tab.o
175gconf-objs := gconf.o zconf.tab.o
Linus Torvalds1da177e2005-04-16 15:20:36 -0700176
Masahiro Yamada022af622014-08-19 16:34:22 +0900177hostprogs-y := conf nconf mconf kxgettext qconf gconf
Linus Torvalds1da177e2005-04-16 15:20:36 -0700178
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400179clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400180clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
EGRY Gabor10200262008-01-11 23:40:00 +0100181clean-files += config.pot linux.pot
Linus Torvalds1da177e2005-04-16 15:20:36 -0700182
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100183# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
184PHONY += $(obj)/dochecklxdialog
185$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
186$(obj)/dochecklxdialog:
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400187 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100188
189always := dochecklxdialog
190
Sam Ravnborgaa1e5ef2007-08-12 23:15:44 +0200191# Add environment specific flags
192HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
Yuri Vasilevski70a6a0c2005-10-30 15:03:20 -0800193
Linus Torvalds1da177e2005-04-16 15:20:36 -0700194# generated files seem to need this to find local include files
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400195HOSTCFLAGS_zconf.lex.o := -I$(src)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700196HOSTCFLAGS_zconf.tab.o := -I$(src)
197
Arnaud Lacombe378dbb22011-05-23 02:08:52 -0400198LEX_PREFIX_zconf := zconf
199YACC_PREFIX_zconf := zconf
200
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400201HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
202HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700203
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400204HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
Adrian Bunk37193142006-01-02 11:25:30 +0100205HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
Arnaud Lacombe1ea3ad42011-06-05 23:36:05 -0400206 -Wno-missing-prototypes
Linus Torvalds1da177e2005-04-16 15:20:36 -0700207
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400208HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
209
Justin Lecher544e7e52013-03-06 14:02:02 +0100210HOSTLOADLIBES_nconf = $(shell \
Brian Norris72859962014-06-04 00:52:31 -0700211 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
212 || pkg-config --libs menu panel ncurses 2>/dev/null \
Justin Lecher544e7e52013-03-06 14:02:02 +0100213 || echo "-lmenu -lpanel -lncurses" )
Linus Torvalds1da177e2005-04-16 15:20:36 -0700214$(obj)/qconf.o: $(obj)/.tmp_qtcheck
215
Masahiro Yamada022af622014-08-19 16:34:22 +0900216ifeq ($(MAKECMDGOALS),xconfig)
Roman Zippelb3a52252005-11-21 21:32:38 -0800217$(obj)/.tmp_qtcheck: $(src)/Makefile
Linus Torvalds1da177e2005-04-16 15:20:36 -0700218-include $(obj)/.tmp_qtcheck
219
Diego Viola092373c2015-04-06 06:27:45 -0300220# Qt needs some extra effort...
Linus Torvalds1da177e2005-04-16 15:20:36 -0700221$(obj)/.tmp_qtcheck:
Michal Marek0a1f00a2015-04-08 13:30:42 +0200222 @set -e; $(kecho) " CHECK qt"; dir=""; pkg=""; \
Alexander Stein133c5f72010-08-31 17:34:37 +0200223 if ! pkg-config --exists QtCore 2> /dev/null; then \
Diego Viola092373c2015-04-06 06:27:45 -0300224 echo "* Unable to find the Qt4 tool qmake. Trying to use Qt3"; \
Alexander Stein133c5f72010-08-31 17:34:37 +0200225 pkg-config --exists qt 2> /dev/null && pkg=qt; \
226 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
227 if [ -n "$$pkg" ]; then \
228 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
229 libs="\$$(shell pkg-config $$pkg --libs)"; \
230 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
231 dir="$$(pkg-config $$pkg --variable=prefix)"; \
232 else \
233 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
234 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
235 done; \
236 if [ -z "$$dir" ]; then \
Michal Marek5b580fa2012-07-07 23:32:18 +0200237 echo >&2 "*"; \
Diego Viola092373c2015-04-06 06:27:45 -0300238 echo >&2 "* Unable to find any Qt installation. Please make sure that"; \
239 echo >&2 "* the Qt4 or Qt3 development package is correctly installed and"; \
Michal Marek5b580fa2012-07-07 23:32:18 +0200240 echo >&2 "* either qmake can be found or install pkg-config or set"; \
241 echo >&2 "* the QTDIR environment variable to the correct location."; \
242 echo >&2 "*"; \
Alexander Stein133c5f72010-08-31 17:34:37 +0200243 false; \
244 fi; \
245 libpath=$$dir/lib; lib=qt; osdir=""; \
246 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
247 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
248 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
249 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
250 cflags="-I$$dir/include"; \
251 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
252 moc="$$dir/bin/moc"; \
253 fi; \
254 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
255 echo "*"; \
256 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
257 echo "*"; \
258 moc="/usr/bin/moc"; \
259 fi; \
Sam Ravnborgab919c02005-11-06 11:05:21 +0100260 else \
Michal Marek458452f2010-09-13 13:41:31 +0200261 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
262 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
Yaakov Selkowitz48485942012-07-04 15:23:29 -0500263 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
264 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
Roman Zippelb3a52252005-11-21 21:32:38 -0800265 fi; \
266 echo "KC_QT_CFLAGS=$$cflags" > $@; \
267 echo "KC_QT_LIBS=$$libs" >> $@; \
268 echo "KC_QT_MOC=$$moc" >> $@
Linus Torvalds1da177e2005-04-16 15:20:36 -0700269endif
270
271$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
272
Masahiro Yamada022af622014-08-19 16:34:22 +0900273ifeq ($(MAKECMDGOALS),gconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700274-include $(obj)/.tmp_gtkcheck
275
Diego Viola39c3f1b2015-05-31 14:35:51 -0300276# GTK+ needs some extra effort, too...
Linus Torvalds1da177e2005-04-16 15:20:36 -0700277$(obj)/.tmp_gtkcheck:
Adrian Bunk37193142006-01-02 11:25:30 +0100278 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
279 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700280 touch $@; \
281 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200282 echo >&2 "*"; \
283 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
284 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700285 false; \
286 fi \
287 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200288 echo >&2 "*"; \
289 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
290 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
291 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
292 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700293 false; \
294 fi
295endif
296
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400297$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
Linus Torvalds1da177e2005-04-16 15:20:36 -0700298
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400299$(obj)/qconf.o: $(obj)/qconf.moc
Linus Torvalds1da177e2005-04-16 15:20:36 -0700300
Yaakov Selkowitzebca0262012-07-04 18:31:11 -0500301quiet_cmd_moc = MOC $@
302 cmd_moc = $(KC_QT_MOC) -i $< -o $@
303
304$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
305 $(call cmd,moc)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700306
Diego Viola39c3f1b2015-05-31 14:35:51 -0300307# Extract gconf menu items for i18n support
EGRY Gabor46d26312008-01-11 23:46:11 +0100308$(obj)/gconf.glade.h: $(obj)/gconf.glade
Peter Foley2d80eb02011-04-26 18:16:53 -0400309 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
Peter Foleya24a1b82011-04-26 18:13:05 -0400310 $(obj)/gconf.glade